#!/bin/sh
cd -- "$(dirname $0)"
sqlite3 mosaic.meta  <<EOS

DROP TABLE IF EXISTS rawmeta ;

CREATE TABLE IF NOT EXISTS rawmeta (
firstname text,
lastname text,
major text,
campus text,
permalink text,
filename text ) ;

.mode csv
.import "meta.csv" rawmeta

ALTER TABLE cells ADD COLUMN firstname text ;
ALTER TABLE cells ADD COLUMN lastname text ;
ALTER TABLE cells ADD COLUMN major text ;
ALTER TABLE cells ADD COLUMN campus text ;
ALTER TABLE cells ADD COLUMN permalink text ;

UPDATE cells SET firstname = (select firstname from rawmeta where filename=cells.filename),
               lastname = (select lastname from rawmeta where filename=cells.filename) ,
               major = (select major from rawmeta where filename=cells.filename) ,
               campus = (select campus from rawmeta where filename=cells.filename) ,
               permalink = (select permalink from rawmeta where filename=cells.filename) ;
 
REINDEX ;

DROP TABLE IF EXISTS people ;

CREATE TABLE people ( row integer, col integer, fromcenter REAL, filename text, comments text,
firstname text,
lastname text,
major text,
campus text,
permalink text ) ;

DELETE FROM people;

INSERT INTO people
SELECT Distinct row,col, min(fromcenter),filename,comments, 
firstname,
lastname,
major,
campus,
permalink FROM cells group by filename order by fromcenter;

ALTER TABLE people ADD COLUMN fullname text ;
UPDATE people SET fullname = firstName || ' ' || LastName ;


CREATE INDEX Idxpeople2 ON people(row);
CREATE INDEX Idxpeople3 ON people(col);

DROP TABLE IF EXISTS rawmeta ;

VACUUM ;
 
.quit


EOS


