/*
	Called by index.php
	Gets call when friends have been grabed with in the last 24 hours
	Calls ajaxLoadingFriends, ajaxCompletedFriends
*/
 var recentData = likeData = clickData = friendData = popularData = 0;

Array.prototype.shuffle = function (){
    var i = this.length, j, temp;
    if ( i == 0 ) return;
    while ( --i ) {
        j = Math.floor( Math.random() * ( i + 1 ) );
        temp = this[i];
        this[i] = this[j];
        this[j] = temp;
    }
};
/*
	Called by index.php
	Ajax call to display recently submitted photos carousel
	Calls loadingRecent, completedRecent
*/
function displayClicked(){
	if(!clickData){
		$.ajax({
			url: "display_clicked.php",
			type: "POST",
			dataType: "html",
			beforeSend: loadingClicked,
			success: function(data) {
				clickData = jQuery.parseJSON(data);
				clickData.shuffle();
				completedClicked();
			}
		});
	}else{
		completedClicked();
	}
}

/*
	Called by displayRecent
	Displays loading image in carousel
*/
function loadingClicked() {
    var f = document.getElementById('displayContainer');
	f.innerHTML = '<div style="vertical-align:middle; text-align:center;"><img style="text-align:center; margin:19px auto 0 auto;" src="images/loading.gif" alt=""/></div>';
}

/*
	Called by displayRecent
	Displays the carousel
	Calls jquery Carousel
*/
function completedClicked() {
    var f = document.getElementById('displayContainer');
	var htmlRecent = '';
	var counter = 0;
	htmlRecent = '<div id="displayClicked" class="owl-carousel">';
	//htmlRecent += '<li><span></span></li>';
	for(i=0;i<clickData.length;i++){
		//var name = clickData[i].lNameNominee ? clickData[i].fNameNominee + ' ' + clickData[i].lNameNominee[0] + '.' : clickData[i].fNameNominee;
		//htmlRecent += '<li><div style="position:relative; width:137px; height:137px"><img class="click" style="height:137px; width:137px;" onclick="setSearchBar(\''+clickData[i].code+'\'); searchViewer(\''+clickData[i].code+'\'); return false;" src="upload_flat_complete/thumbnail/'+clickData[i].code+'.jpg" alt=""/><div style="position:absolute; bottom:0; left:0; height:28px; width:100%; background:url(images/search_highlight.png);"><span style="position:absolute; left:3px; line-height:28px;" class="white_14">'+name+'</span><span style="position:absolute; right:3px; bottom:3px; width:23px; height:23px; line-height:23px; text-align:center; border-radius:23px; background:#e3e3e3;" class="blue_12">'+clickData[i].clicks+'</span></div></div></li>';
		var name = clickData[i].lname ? clickData[i].fname + ' ' + clickData[i].lname[0] + '.' : clickData[i].fname;

		htmlRecent += '<li><div style="width:120px; height:120px; border:4px solid #50849d; position:relative;"><img class="click" style="height:120px; width:120px;" onclick="searchViewerAnimation(\''+clickData[i].code+'\'); return false;" src="upload_flat_complete/thumbnail/'+clickData[i].code+'.jpg" alt=""/><div style="position:absolute; bottom:0; left:0; height:28px; width:100%; background:url(images/carouselBackground.png);"><span style="position:absolute; left:3px; line-height:28px;" class="white_14">'+name+'</span><span style="position:absolute; right:3px; bottom:3px; width:23px; height:23px; line-height:23px; text-align:center; border-radius:23px; background:#e3e3e3;" class="blue_12">'+clickData[i].clicks+'</span></div></div></li>';
		counter++;
	}
	htmlRecent += '</ul>';
	f.innerHTML = htmlRecent;
	$('.owl-carousel').owlCarousel({
    		loop:false,
    		margin:10,
   			responsiveBaseWidth: "#carouselArea",
			nav:false,
			dots:false,
			autoWidth:true,
	});
		var owl = $('.owl-carousel');
		owl.owlCarousel();
		if(counter > itemsPerPage) {
			$('#rightArrowPhotos').click(function() {
    			owl.trigger('next.owl.carousel');
			})
			$('#leftArrowPhotos').click(function() {
    			owl.trigger('prev.owl.carousel', [300]);
			})
			$('#leftArrowPhotos').css('display', 'block');
			$('#rightArrowPhotos').css('display', 'block');
		} else {
			$('#leftArrowPhotos').css('display', 'none');
			$('#rightArrowPhotos').css('display', 'none');
		}
		$('.owl-stage-outer').css('height', '137px');
}

function slideObj(tween){
		var l = tween.target.l;
		$('#slidePiece').css({
			'right': (~~l)+'px'
		});
}

function closeSlide() {
	if(!slideClosed) {
	var fro = {l:0};
	TweenLite.to(fro, 1, {l:-305, onStart:disableOnclick, onUpdate:slideObj, onUpdateParams:["{self}"], onComplete:doneSliding, onCompleteParams:[1]});
	slideClosed = 1;
	}
}

function doneSliding(param) {
	if(param) {
		$(".slideArrow").css("background-position", "-56px 0");
		$('#slidePiece').attr('onclick', 'openSlide();');
		//document.getElementById('slidePiece').innerHTML = '<img class="click" id="slideImage" onclick="openSlide()" src="images/slideOut.png" alt="" />';
	} else {
		$(".slideArrow").css("background-position", "-47px 0");
		$('#slidePiece').attr('onclick', 'closeSlide();');
		//document.getElementById('slidePiece').innerHTML = '<img class="click" id="slideImage" onclick="closeSlide()" src="images/slideIn.png" alt="" />';
	}
}

function openSlide() {
	if(slideClosed) {
		var fro = {l:-305};
		TweenLite.to(fro, 1, {l:0, onStart:disableOnclick, onUpdate:slideObj, onUpdateParams:["{self}"], onComplete:doneSliding, onCompleteParams:[0]});
	slideClosed = 0;
	}
}

function disableOnclick() {
	document.getElementById('slidePiece').onclick = null;
}

/*
	Called by index.php
	Ajax call to display recently submitted photos carousel
	Calls loadingRecent, completedRecent
*/
function displayRecent(){
	if(!recentData){
		$.ajax({
			url: "display_recent.php",
			type: "POST",
			dataType: "html",
			beforeSend: loadingRecent,
			success: function(data) {
				recentData = jQuery.parseJSON(data);
				//recentData.shuffle();
				completedRecent();
			}
		});
	}else{
		completedRecent();
	}
}

/*
	Called by displayRecent
	Displays loading image in carousel
*/
function loadingRecent() {
    var f = document.getElementById('displayContainer');
	f.innerHTML = '<div style="vertical-align:middle; text-align:center;"><img style="text-align:center; margin:19px auto 0 auto;" src="images/loading.gif" alt=""/></div>';
}

/*
	Called by displayRecent
	Displays the carousel
	Calls jquery Carousel
*/
function completedRecent() {
	//document.getElementById('mostRec').style.backgroundColor = '#0057a7';
	//document.getElementById('mostRec').innerHTML = '<span class="white_14">Most Recent Photos</span>';
	//document.getElementById('mostPop').style.backgroundColor = '#FFF';
	//document.getElementById('mostPop').innerHTML = '<span class="blue_14">Most Liked</span>';
	//document.getElementById('staff').style.backgroundColor = '#FFF';
	//document.getElementById('staff').innerHTML = '<span class="blue_14">Staff</span>';
    var f = document.getElementById('displayContainer');
	var htmlRecent = '';
	var counter = 0;
	htmlRecent = '<div class="owl-carousel">';

	for(i=0;i<recentData.length;i++){
		var name = recentData[i].lname ? recentData[i].fname + ' ' + recentData[i].lname[0] + '.' : recentData[i].fname;
		htmlRecent += '<li><div style="width:120px; height:120px; border:4px solid #50849d; position:relative;"><img class="click" style="height:120px; width:120px;" onclick="searchViewerAnimation(\''+recentData[i].code+'\'); return false;" src="upload_flat_complete/thumbnail/'+recentData[i].code+'.jpg" alt=""/><div style="position:absolute; bottom:0; left:0; height:28px; width:100%; background:url(images/carouselBackground.png);"><span style="position:absolute; left:3px; line-height:28px;" class="white_14">'+name+'</span></div></div></li>';
		counter++;
	}
	htmlRecent += '</ul>';
	f.innerHTML = htmlRecent;
	/*$('.owl-carousel').owlCarousel({
			items : 7,
    		loop:true,
    		margin:0,
   			nav:false,
			dots:false
		});*/
		$('.owl-carousel').owlCarousel({
    		loop:false,
    		margin:10,
   			responsiveBaseWidth: "#carouselArea",
			nav:false,
			dots:false,
			autoWidth:true,
	});
		var owl = $('.owl-carousel');
		owl.owlCarousel();
		if(counter > itemsPerPage) {
			$('#rightArrowPhotos').click(function() {
    			owl.trigger('next.owl.carousel');
			})
			$('#leftArrowPhotos').click(function() {
    			owl.trigger('prev.owl.carousel', [300]);
			})
			$('#leftArrowPhotos').css('display', 'block');
			$('#rightArrowPhotos').css('display', 'block');
		} else {
			$('#leftArrowPhotos').css('display', 'none');
			$('#rightArrowPhotos').css('display', 'none');
		}
}